﻿using System;
using System.Drawing;

using DevExpress.XtraMap;

namespace TestProject
{
    /// <summary>
    /// 커스텀 맵 색상화기
    /// </summary>
    public class CustomMapColorizer : MapColorizer
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 색상 배열
        /// </summary>
        private Color[] colorArray =
        {
            Color.Violet,
            Color.Blue,
            Color.LightBlue,
            Color.Green,
            Color.Yellow,
            Color.Orange,
            Color.Red
        };

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 요소 색상 표시하기 - ColorizeElement(colorizerElement)

        /// <summary>
        /// 요소 색상 표시하기
        /// </summary>
        /// <param name="colorizerElement">색상화기 요소 인터페이스</param>
        public override void ColorizeElement(IColorizerElement colorizerElement)
        {
            MapPolygon polygon = colorizerElement as MapPolygon;

            if(polygon != null)
            {
                double power = (double)polygon.Attributes["PowerValue"].Value;

                int linearizedPower = (int)Math.Truncate(power * colorArray.Length / 1000);

                colorizerElement.ColorizerColor = colorArray[linearizedPower];
            }
        }

        #endregion
    }
}